#ifndef _KFbxTransformation_h
#define _KFbxTransformation_h

/**************************************************************************************

 Copyright  2003 - 2005 Systmes Alias Qubec Inc. and/or its licensors.  
 All rights reserved.

 The coded instructions, statements, computer programs, and/or related material 
 (collectively the "Data") in these files contain unpublished information proprietary
 to Systmes Alias Qubec Inc. and/or its licensors, which is protected by Canadian
 and US federal copyright law and by international treaties.

 The Data may not be disclosed or distributed to third parties, in whole or in part,
 without the prior written consent of Alias Systems Corp. (Alias).

 THE DATA IS PROVIDED AS IS AND WITHOUT WARRANTY. ALL WARRANTIES ARE EXPRESSLY
 EXCLUDED AND DISCLAIMED. ALIAS MAKES NO WARRANTY OF ANY KIND WITH RESPECT TO THE DATA,
 EXPRESS, IMPLIED OR ARISING BY CUSTOM OR TRADE USAGE, AND DISCLAIMS ANY IMPLIED
 WARRANTIES OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR 
 PURPOSE. IN NO EVENT SHALL ALIAS, ITS AFFILIATES, PARENT COMPANIES, LICENSORS OR 
 SUPPLIERS (ALIAS GROUP) BE LIABLE FOR ANY DAMAGES OR EXPENSES OF ANY KIND INCLUDING
 WITHOUT LIMITATION PUNITIVE OR MULTIPLE DAMAGES OR OTHER SPECIAL, DIRECT, INDIRECT, 
 EXEMPLARY, INCIDENTAL, OR CONSEQUENTIAL DAMAGES OF ANY KIND, WHETHER OR NOT ALIAS HAS
 BEEN ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWSOEVER CAUSED AND ON ANY THEORY OF
 LIABILITY. 

**************************************************************************************/

#include <kaydaradef.h>
#ifndef KFBX_DLL 
	#define KFBX_DLL K_DLLIMPORT
#endif

#include <kaydara.h>

/** \enum ERotationOrder Rotation order flags.
  * - \e eEULER_XYZ
  * - \e eEULER_XZY
  * - \e eEULER_YZX 
  * - \e eEULER_YXZ 
  * - \e eEULER_ZXY 
  * - \e eEULER_ZYX
  * - \e eSPHERIC_XYZ
  */
typedef enum 
{ 
	eEULER_XYZ = 0, 
	eEULER_XZY, 
	eEULER_YZX, 
	eEULER_YXZ, 
	eEULER_ZXY, 
	eEULER_ZYX,
	eSPHERIC_XYZ
} ERotationOrder;

/** \enum ETransformInheritType Tranformation inheritance flags.
  * - \e eINHERIT_RrSs
  * - \e eINHERIT_RSrs
  * - \e eINHERIT_Rrs 
  */
typedef enum 
{
	eINHERIT_RrSs = 0, 
	eINHERIT_RSrs, 
	eINHERIT_Rrs 
} ETransformInheritType;


#endif // _KFbxTransformation_h
