#ifndef _KFbxSceneInfo_h
#define _KFbxSceneInfo_h

/**************************************************************************************

 Copyright  2005 Systmes Alias Qubec Inc. and/or its licensors.  
 All rights reserved.

 The coded instructions, statements, computer programs, and/or related material 
 (collectively the "Data") in these files contain unpublished information proprietary
 to Systmes Alias Qubec Inc. and/or its licensors, which is protected by Canadian
 and US federal copyright law and by international treaties.

 The Data may not be disclosed or distributed to third parties, in whole or in part,
 without the prior written consent of Alias Systems Corp. (Alias).

 THE DATA IS PROVIDED AS IS AND WITHOUT WARRANTY. ALL WARRANTIES ARE EXPRESSLY
 EXCLUDED AND DISCLAIMED. ALIAS MAKES NO WARRANTY OF ANY KIND WITH RESPECT TO THE DATA,
 EXPRESS, IMPLIED OR ARISING BY CUSTOM OR TRADE USAGE, AND DISCLAIMS ANY IMPLIED
 WARRANTIES OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR 
 PURPOSE. IN NO EVENT SHALL ALIAS, ITS AFFILIATES, PARENT COMPANIES, LICENSORS OR 
 SUPPLIERS (ALIAS GROUP) BE LIABLE FOR ANY DAMAGES OR EXPENSES OF ANY KIND INCLUDING
 WITHOUT LIMITATION PUNITIVE OR MULTIPLE DAMAGES OR OTHER SPECIAL, DIRECT, INDIRECT, 
 EXEMPLARY, INCIDENTAL, OR CONSEQUENTIAL DAMAGES OF ANY KIND, WHETHER OR NOT ALIAS HAS
 BEEN ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWSOEVER CAUSED AND ON ANY THEORY OF
 LIABILITY. 

**************************************************************************************/

#include <kaydaradef.h>
#ifndef KFBX_DLL 
	#define KFBX_DLL K_DLLIMPORT
#endif

#include <kaydara.h>

#include <klib/kstring.h>

class KStreamFbx; 

#include <kfbxplugins/kfbxnamespacedef.h>
namespace FBXSDK_NAMESPACE {

class KFbxThumbnail;

/** Contains scene thumbnail and user-defined summary data.
  */
class KFBX_DLL KFbxSceneInfo
{

public:

	/** User-defined summary data.
	  * Those fields are filled by the user to identify/classify
	  * the files.
	  */
	//@{
	//! Title.
	KString mTitle;

	//! Subject.
	KString mSubject;

	//! Author.
	KString mAuthor;

	//! Keywords.
	KString mKeywords;

	//! Revision.
	KString mRevision;

	//! Comment.
	KString mComment;
	//@}

	/** Scene Thumbnail.
	  */
	//@{

	/** Get the scene thumbnail.
	  * \return Pointer to the thumbnail.
	  */
	KFbxThumbnail* GetSceneThumbnail();

	/** Set the scene thumbnail.
	  * \param pSceneThumbnail Pointer to a thumbnail object.
	  */
	void SetSceneThumbnail(KFbxThumbnail* pSceneThumbnail);
	//@}

	/** Clear the content.
	  * Reset all the strings to the empty string and clears 
	  * the pointer to the thumbnail.
	  */
	void Clear();

	//! assignment operator.
	KFbxSceneInfo& operator=(const KFbxSceneInfo& pSceneInfo);

///////////////////////////////////////////////////////////////////////////////
//
//  WARNING!
//
//	Anything beyond these lines may not be documented accurately and is 
// 	subject to change without notice.
//
///////////////////////////////////////////////////////////////////////////////
#ifndef DOXYGEN_SHOULD_SKIP_THIS

protected:

	//! Constructor.
	KFbxSceneInfo();

	//! Destructor.
	~KFbxSceneInfo();

	KFbxThumbnail* mSceneThumbnail;

	friend class KFbxSdkManager;
	friend class KStreamFbx;
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS 
};

typedef KFbxSceneInfo* HKFbxSceneInfo;

} // namespace
#endif // #ifndef _KFbxSceneInfo_h


