#ifndef NX_COLLISION_CAPSULECONTROLLER
#define NX_COLLISION_CAPSULECONTROLLER
/*----------------------------------------------------------------------------*\
|
|								NovodeX Technology
|
|							     www.novodex.com
|
\*----------------------------------------------------------------------------*/

/* Exclude from documentation */
/** \cond */

#include "Controller.h"
#include "NxCapsuleController.h"

class CapsuleController : public NxCapsuleController, public Controller
	{
	public:
									CapsuleController(const NxControllerDesc& desc, NxScene* scene);
	virtual							~CapsuleController();

	virtual	NxController*			getController()								{ return this;							}

	virtual	void					move(const NxVec3& disp, NxU32 activeGroups, NxF32 minDist, NxU32& collisionFlags, NxF32 sharpness);

	virtual	bool					setPosition(const NxExtendedVec3& position)	{ return setPos(position);				}

	virtual	void					setStepOffset(const float offset);

	virtual	NxActor*				getActor()							const	{ return Controller::getActor();		}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// NxCapsuleController
	virtual	NxF32					getRadius()							const;
	virtual	NxF32					getHeight()							const;
	virtual	bool					setRadius(NxF32 radius);
	virtual	bool					setHeight(NxF32 height);
	//~ NxCapsuleController

	virtual	const NxExtendedVec3&	getPosition()						const	{ return exposedPosition;				}
	virtual	const NxExtendedVec3&	getFilteredPosition()				const	{ return exposedPosition;				}
	virtual const NxExtendedVec3&	getDebugPosition()					const	{ return position;						}
	virtual	bool					getWorldBox(NxExtendedBounds3& box) const;
	virtual	void					setCollision(bool enabled)					{ Controller::setCollision(enabled);	}

			NxF32					radius;
			NxF32					height;
	};

/** \endcond */
#endif
