/****************************************************************************\
*                                                                            *
* 13.05.2006                                                                 *
* CPhysXCharacter - Source File                                              *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <NxController.h>
#include <NxActor.h>
#include "CPhysXCharacter.h"
#include "CPhysXActor.h"

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
void CPhysXCharacter::SetPos(const CVector3f &vPos)
{
    m_pController->setPosition(NxExtendedVec3(vPos.m_X, vPos.m_Y, vPos.m_Z));
}

const CVector3f CPhysXCharacter::GetPos() const
{
    NxExtendedVec3 vExPos = m_pController->getFilteredPosition();

    return CVector3f((float) vExPos.x, (float) vExPos.y, (float) vExPos.z);
}

void CPhysXCharacter::Move(const CVector3f &vDistance, dword dwCollisionGroups)
{
    NxU32 tmp;

	m_pController->move(NxVec3(vDistance.m_X, vDistance.m_Y, vDistance.m_Z), dwCollisionGroups, 0.001f, tmp);
    m_dwCollisionFlags = tmp;
}

CPhysXCharacter::~CPhysXCharacter()
{
}

bool CPhysXCharacter::GroundContact() const
{
    return (m_dwCollisionFlags & NXCC_COLLISION_DOWN) != 0;
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/
CPhysXCharacter::CPhysXCharacter(NxController *pController) : m_pController(pController), m_dwCollisionFlags(0)
{
}

