/****************************************************************************\
*                                                                            *
* 10.05.2006                                                                 *
* CPhysXMesh - Header File                                                   *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CPHYSXMESH_H__
#define __CPHYSXMESH_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class NxTriangleMesh;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CPhysXMesh : public IManagedObject
{
    friend class CPhysXMgr;
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        virtual ~CPhysXMesh();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        CPhysXMesh(NxTriangleMesh *pMesh);

        //Private copy constructor and assignment operator to prevent mistakes:
        CPhysXMesh(const CPhysXMesh &);
        const CPhysXMesh &operator =(const CPhysXMesh &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        NxTriangleMesh *m_pMesh;
};

#endif
