/****************************************************************************\
*                                                                            *
* 02.06.2006                                                                 *
* IPhysXObj - Header File                                                    *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __IPHYSXOBJ_H__
#define __IPHYSXOBJ_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class IGameObj;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IPhysXObj
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
		IPhysXObj();
        
		void CollidedWith(IPhysXObj *pOther);
		inline void SetObject(IGameObj *pObj) {m_pObj = pObj;}
		inline IGameObj *GetObject() const {return m_pObj;}
        
        virtual ~IPhysXObj();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        IPhysXObj(const IPhysXObj &);
        const IPhysXObj &operator =(const IPhysXObj &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		IGameObj *m_pObj;        
};

#endif
