/****************************************************************************\
*                                                                            *
* 16.04.2006                                                                 *
* CFlyCamCtrl - Header File                                                  *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CFLYCAMCTRL_H__
#define __CFLYCAMCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/TSmartPointer.h>
#include <Input/IInputHandler.h>
#include <Timer/CTimer.h>
#include "ICamCtrl.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CFlyCamCtrl : public ICamCtrl, private IInputHandler
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CFlyCamCtrl(const TSmartPointer<CTimer> &pTimer, word wInputPriority);
        
        void Enable(const TSmartPointer<CCamera> &pCamera);
        void Update();
        void Disable();
        
        virtual ~CFlyCamCtrl();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        virtual bool OnMouseMove(sdword sdwX, sdword sdwY, sdword sdwZ);
        virtual bool OnKeyDown(dword dwKey);
        virtual bool OnKeyUp(dword dwKey);
        //Private copy constructor and assignment operator to prevent mistakes:
        CFlyCamCtrl(const CFlyCamCtrl &);
        const CFlyCamCtrl &operator =(const CFlyCamCtrl &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        bool m_bForward, m_bBackward;
        bool m_bLeft, m_bRight;

        TSmartPointer<CTimer> m_pTimer;
};

#endif
