/****************************************************************************\
*                                                                            *
* 25.04.2006                                                                 *
* ICamCtrl - Header File                                                     *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __ICAMCTRL_H__
#define __ICAMCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
#include <Memory/TSmartPointer.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CCamera;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class ICamCtrl : public IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        ICamCtrl();
        
        virtual void Enable(const TSmartPointer<CCamera> &pCamera);
        virtual void Update() = 0;
        virtual void Disable();

        inline bool IsEnabled() {return (bool) m_pCamera;}
        
        virtual ~ICamCtrl();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        ICamCtrl(const ICamCtrl &);
        const ICamCtrl &operator =(const ICamCtrl &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        TSmartPointer<CCamera> m_pCamera;
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        
};

#endif
