/****************************************************************************\
*                                                                            *
* 26.03.2006                                                                 *
* CGuiText - Header File                                                     *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CGUITEXT_H__
#define __CGUITEXT_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Renderer/IFont.h>
#include "IGuiObject.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CGuiText : public IGuiObject
{
    friend class CGuiMgr;
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        //State setting
        virtual void SetPos(const CVector3f &vPos);
        void SetText(const std::string &sText);
        void SetColor(dword dwColor);

        virtual void Destroy();        
        
        virtual ~CGuiText() {Destroy();}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        CGuiText(const TSmartPointer<IFont> &pFont);
        virtual void RenderSub();
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        void Clear();


        //Private copy constructor and assignment operator to prevent mistakes:
        CGuiText(const CGuiText &);
        CGuiText &operator =(const CGuiText &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        SText m_TextInfo;
        TSmartPointer<IFont> m_pFont;
        
};

#endif
