/****************************************************************************\
*                                                                            *
* 22.04.2006                                                                 *
* CGuiWnd - Source File                                                      *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "CGuiWnd.h"
#include "CEngineFactory.h" //Debug
#include <gl/GL.h> //Debug

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
bool CGuiWnd::OnMouseKeyDown(byte bKey)
{
    if(CGuiContainer::OnMouseKeyDown(bKey))
        return true;

    if(IsVisible())
    {
        CGuiMgr *pMgr(CEngineFactory::InstancePtr()->GetGuiMgr());
        CVector2f vCursor(pMgr->GetCursorPos());
        CVector3f vAbsPos(GetAbsPos());
        if(vCursor.m_X >= vAbsPos.m_X && vCursor.m_X <= vAbsPos.m_X + GetScale().m_X &&
            vCursor.m_Y >= vAbsPos.m_Y && vCursor.m_Y <= vAbsPos.m_Y + GetScale().m_Y)
        {
            return true;
        }
    }

    return false;
}

bool CGuiWnd::OnMouseKeyUp(byte bKey)
{
    if(CGuiContainer::OnMouseKeyUp(bKey))
        return true;

    if(IsVisible())
    {
        CGuiMgr *pMgr(CEngineFactory::InstancePtr()->GetGuiMgr());
        CVector2f vCursor(pMgr->GetCursorPos());
        CVector3f vAbsPos(GetAbsPos());
        if(vCursor.m_X >= vAbsPos.m_X && vCursor.m_X <= vAbsPos.m_X + GetScale().m_X &&
            vCursor.m_Y >= vAbsPos.m_Y && vCursor.m_Y <= vAbsPos.m_Y + GetScale().m_Y)
        {
            return true;
        }
    }

    return false;
}

bool CGuiWnd::OnMouseMove(float fX, float fY, sdword sdwZ)
{
    if(CGuiContainer::OnMouseMove(fX, fY, sdwZ))
        return true;

    if(IsVisible())
    {
        CGuiMgr *pMgr(CEngineFactory::InstancePtr()->GetGuiMgr());
        CVector2f vCursor(pMgr->GetCursorPos());
        CVector3f vAbsPos(GetAbsPos());
        if(vCursor.m_X >= vAbsPos.m_X && vCursor.m_X <= vAbsPos.m_X + GetScale().m_X &&
            vCursor.m_Y >= vAbsPos.m_Y && vCursor.m_Y <= vAbsPos.m_Y + GetScale().m_Y)
        {
            return true;
        }
    }
    return false;
}

CGuiWnd::~CGuiWnd()
{

}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/
void CGuiWnd::RenderSub()
{
	CMatrix44 scale;
	scale.Scaling(GetScale());
	CEngineFactory::InstancePtr()->GetRenderer()->SaveMatrix();
	CEngineFactory::InstancePtr()->GetRenderer()->MultMatrix(scale);
	m_pRep->Render();

	CEngineFactory::InstancePtr()->GetRenderer()->RestoreMatrix();

    CGuiContainer::RenderSub();
}

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/
void CGuiWnd::Clear()
{

}