/****************************************************************************\
*                                                                            *
* 22.04.2006                                                                 *
* CGuiWnd - Header File                                                      *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CGUIWND_H__
#define __CGUIWND_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "CGuiContainer.h"
#include <Renderer/IStockGeometry.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CGuiWnd : public CGuiContainer
{
    friend class CGuiMgr;
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
		inline void SetRep(IStockGeometry *obj) {m_pRep = obj;}

        virtual bool OnMouseKeyDown(byte bKey);
        virtual bool OnMouseKeyUp(byte bKey);
        virtual bool OnMouseMove(float fX, float fY, sdword sdwZ);
        virtual ~CGuiWnd();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        CGuiWnd() : CGuiContainer() {Clear();}
        void RenderSub();
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        void Clear();

       //Private copy constructor and assignment operator to prevent mistakes:
        CGuiWnd(const CGuiWnd &);
        const CGuiWnd &operator =(const CGuiWnd &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		TSmartPointer<IStockGeometry> m_pRep;        
};

#endif
