/****************************************************************************\
*                                                                            *
* 27.03.2006                                                                 *
* CTGALoader - Header File                                                   *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CTGALOADER_H__
#define __CTGALOADER_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Loader/ITextureLoader.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CTGALoader : public ITextureLoader
{
	/**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
		CTGALoader(){}

		virtual bool LoadImage(std::string &filename,TSmartPointer<CImageInfo>);

        virtual ~CTGALoader(){}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
		
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        CTGALoader(const CTGALoader &);
        CTGALoader &operator =(const CTGALoader &);

		bool LoadUncompressedTGA(FILE *fTGA, dword &width, dword &height, bool &alpha, BYTE *bits);
		bool LoadCompressedTGA(FILE *fTGA, dword &width, dword &height, bool &alpha, BYTE *bits);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        
};

#endif
