
/****************************************************************************\
*                                                                            *
* 27.03.2006                                                                 *
* IModelLoader - Header File                                                 *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __IMODELLOADER_H__
#define __IMODELLOADER_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Memory/TSmartPointer.h>
#include "ModelStructs.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/


/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IModelLoader : public IManagedObject
{
	/**************************************************************************\
	* PUBLIC CLASS FUNCTIONS                                                   *
	\**************************************************************************/
public:
	IModelLoader(){m_pGeoInfo = NULL;m_pAniInfo = NULL;m_pSkelInfo = NULL;}
	virtual ~IModelLoader(){};

	virtual bool Load(const std::string &)                             = 0;
	virtual bool LoadAndTriangulate(const std::string &)               = 0;
	virtual bool GetGeometryInfo(TSmartPointer<CGeometryInfo> const)   = 0;
	virtual bool GetAnimationInfo(TSmartPointer<CAnimationInfo> const) = 0;
	virtual bool GetSkeletonInfo(TSmartPointer<CSkeletonInfo> const)   = 0;

	/**************************************************************************\
	* PROTECTED CLASS FUNCTIONS                                                *
	\**************************************************************************/
protected:

	/**************************************************************************\
	* PRIVATE CLASS FUNCTIONS                                                  *
	\**************************************************************************/
private:
	//Private copy constructor and assignment operator to prevent mistakes:
	IModelLoader(const IModelLoader &);
	IModelLoader &operator =(const IModelLoader &);

	/**************************************************************************\
	* PROTECTED CLASS MEMBERS                                                  *
	\**************************************************************************/
protected:
	CGeometryInfo  * m_pGeoInfo;
	CAnimationInfo * m_pAniInfo;
	CSkeletonInfo  * m_pSkelInfo;

	/**************************************************************************\
	* PRIVATE CLASS MEMBERS                                                    *
	\**************************************************************************/
private:

};

#endif