/****************************************************************************\
*                                                                            *
* 18.03.2006                                                                 *
* ITextureLoader - Header File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __ITEXTURELOADER_H__
#define __ITEXTURELOADER_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
#include <Memory/TSmartPointer.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

class CImageInfo : public IManagedObject{

public:
	
	CImageInfo(){ m_pData = NULL; m_bMipMaps = false;}
	~CImageInfo(){SAFE_DELETE_ARRAY(m_pData);}
	
	std::string fileName;
	dword m_ID;
	bool  m_bMipMaps;
	word  m_Width;
	word  m_Height;
	bool  m_bAlpha;
	byte  m_Bpp;
	byte *m_pData;

};

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class ITextureLoader : public IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
		ITextureLoader(){}

		virtual bool LoadImage(std::string &filename,TSmartPointer<CImageInfo>) = 0;

		virtual ~ITextureLoader(){}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        ITextureLoader(const ITextureLoader &);
        ITextureLoader &operator =(const ITextureLoader &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        
};

#endif
