/****************************************************************************\
*                                                                            *
* 22.05.2005                                                                 *
* IManagedObject - Header File                                               *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __IMANAGEDOBJECT_H__
#define __IMANAGEDOBJECT_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        virtual ~IManagedObject() {}

        inline void AddRef() {++m_wRefCount;}
        inline bool Release() {return (--m_wRefCount <= 0);}

        inline word GetRefCount() const {return m_wRefCount;}

    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        //Protected constructor to prevent direct instantiation (this is an interface, man!)
        IManagedObject() : m_wRefCount(0) {}

    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Copy constructor and assignment operator:
        IManagedObject(const IManagedObject &);
        IManagedObject &operator=(const IManagedObject &);

    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        word m_wRefCount;
};

#endif
