/****************************************************************************\
*                                                                            *
* 17.02.2006                                                                 *
* CStdApp - Header File                                                      *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __CSTDAPP_H__
#define __CSTDAPP_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CStdApp
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CStdApp() {m_hInstance = 0;};

        int RunApp(HINSTANCE hInstance);    //Starts main loop

        virtual ~CStdApp() {m_hInstance = 0;};
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:         //Functions to overload with gamespecific stuff
        virtual bool Create() = 0;
        virtual bool Update() = 0;
        virtual void Destroy() = 0;
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        CStdApp(const CStdApp &);
        CStdApp &operator =(const CStdApp &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        HINSTANCE m_hInstance;            //Our Application Instance Handler
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        
};

#endif
