/****************************************************************************\
*                                                                            *
* 24.02.2006                                                                 *
* IObserver - Header File                                                    *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __IOBSERVER_H__
#define __IOBSERVER_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IObserver
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        IObserver() {};
        
        virtual void Notify() = 0;
        
        virtual ~IObserver() {};
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        IObserver(const IObserver &);
        IObserver &operator =(const IObserver &);
};

#endif
