/****************************************************************************\
*                                                                            *
* 21.06.2003                                                                 *
* Tools - Header File                                                        *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __TOOLS_H__
#define __TOOLS_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>

/****************************************************************************\
* DEFINITIONS	                                                              *
\****************************************************************************/

/****************************************************************************\
* NAMESPACE                                                                  *
\****************************************************************************/
namespace Tools
{
  dword ReadWord(const char *pMem, dword dwAvailable, string &sDest);
  dword ReadLine(const char *pMem, dword dwAvailable, string &sDest);
  void AppendBackslash(string &sStr);
  void RemoveEndBackslash(string &sStr);
  const char *GetFileName(const char *sPath);
  const char *GetFirstDir(const char *sPath, string &sDest);

  string GetFileExtension(const string &sFileName);     //Gibt die Erweiterung INKLUSIVE Punkt zurck
  void TryFileExtension(string &sFileName, const char *sExtension);
  void ForceFileExtension(string &sFileName, const char *sExtension);

  inline dword GetAlignUp(dword dwValue, dword dwAlignment) {return (dwValue + dwAlignment - 1) & ~(dwAlignment - 1);}
  inline dword GetAlignDown(dword dwValue, dword dwAlignment) {return dwValue & ~(dwAlignment - 1);}
};

#endif
