/****************************************************************************\
*                                                                            *
* 23.03.2006                                                                 *
* COGLFont - Source File                                                     *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "COGLFont.h"
#include "COGLRenderer.h"

#include <gl/GL.h>

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
void COGLFont::RenderText(SText *pText)
{
	m_pRenderer->RenderText(this, pText);
}

/*
void COGLFont::ClearAllText()
{
	m_allText.clear();
}
*/

COGLFont::~COGLFont()
{
    if(m_Start)	
    {
        ::glDeleteLists(m_Start, m_Quantity);
    }
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/
COGLFont::COGLFont(COGLRenderer *pRenderer)
{
    assert(pRenderer && "Error: NULL Renderer passed to COGLFont constructor");
    m_pRenderer = pRenderer;
    m_Quantity = 0;
	m_Start    = 0;
	m_Base     = 0;
}