/****************************************************************************\
*                                                                            *
* 23.03.2006                                                                 *
* COGLFont - Header File                                                        *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __COGLFONT_H__
#define __COGLFONT_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Renderer/IFont.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class COGLFont : public IFont
{
    friend class COGLRenderer;
	/**************************************************************************\
	* PUBLIC CLASS FUNCTIONS                                                   *
	\**************************************************************************/
    public:
        virtual void RenderText(SText *pText);
    /*
	    virtual void ClearAllText();
    */
	    virtual ~COGLFont();
	
	/**************************************************************************\
	* PROTECTED CLASS FUNCTIONS                                                *
	\**************************************************************************/
    protected:
        COGLFont(COGLRenderer *pRenderer);

	/**************************************************************************\
	* PRIVATE CLASS FUNCTIONS                                                  *
	\**************************************************************************/
    private:
	    //Private copy constructor and assignment operator to prevent mistakes:
	    COGLFont(const COGLFont &);
	    COGLFont &operator =(const COGLFont &);

	/**************************************************************************\
	* PROTECTED CLASS MEMBERS                                                  *
	\**************************************************************************/
    protected:
	    int m_Quantity;  // number of display lists, input to glGenLists
	    int m_Start;     // start index, output from glGenLists
	    int m_Base;      // base index for glListBase

        COGLRenderer *m_pRenderer;    //The renderer that created the object
};

#endif
