/****************************************************************************\
*                                                                            *
* 06.06.2006                                                                 *
COGLMultiPass - Source File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "COGLMultiPass.h"
#include "gl/gl.h"

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/

bool COGLMultiPass::Create(TSmartPointer<CCamera> pCamera,byte nmbPasses){
	
	m_pCamera   = pCamera;
	m_nmbPasses = nmbPasses;
	glClearAccum(0.0,0.0,0.0,0.0);
	return true;
}

void COGLMultiPass::BeginMultiPass(EMultiPassEffect eMode){
	glDrawBuffer(GL_BACK);
	glReadBuffer(GL_BACK);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_ACCUM_BUFFER_BIT);
	m_currentPass = 0;
};
void COGLMultiPass::NextPass(){
	glAccum(GL_ACCUM,(float)1.0f/m_nmbPasses);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); 
	++m_currentPass;
};
void COGLMultiPass::EndMultiPass(){
	glAccum(GL_RETURN,1.0f);
	m_currentPass = 0;

};
/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/