/****************************************************************************\
*                                                                            *
* 29.04.2006                                                                 *
* COGLStockGeometry - Header File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __COGLSTOCKGEOMETRY_H__
#define __COGLSTOCKGEOMETRY_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
#include <Renderer/IStockGeometry.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class COGLRenderer;
class COGLModelFactory;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class COGLStockGeometry : public IStockGeometry
{

	friend class COGLRenderer;
	friend class COGLModelFactory;

	/**************************************************************************\
	* PUBLIC CLASS FUNCTIONS                                                   *
	\**************************************************************************/
public:
	COGLStockGeometry(COGLRenderer *pRenderer,COGLModelFactory *host, word dispListNmb, EBlendingMode blendingMode);
	
	virtual void Render();
	
    virtual ~COGLStockGeometry(){Destroy();}

	/**************************************************************************\
	* PROTECTED CLASS FUNCTIONS                                                *
	\**************************************************************************/
protected:

	/**************************************************************************\
	* PRIVATE CLASS FUNCTIONS                                                  *
	\**************************************************************************/
private:
	//Private copy constructor and assignment operator to prevent mistakes:
	COGLStockGeometry(const COGLStockGeometry &);
	COGLStockGeometry &operator =(const COGLStockGeometry &);

	virtual void Destroy();

	/**************************************************************************\
	* PROTECTED CLASS MEMBERS                                                  *
	\**************************************************************************/
protected:

	/**************************************************************************\
	* PRIVATE CLASS MEMBERS                                                    *
	\**************************************************************************/
private:

	COGLModelFactory *m_pHost;
	COGLRenderer     *m_pRenderer;
    word              m_dispListNmb;
	EBlendingMode	  m_BlendingMode;

};

#endif