/****************************************************************************\
*                                                                            *
* 18.03.2006                                                                 *
* IFont - Header File                                                        *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __IFONT_H__
#define __IFONT_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
#include <Memory/TSmartPointer.h>
#include <Math/TVector3.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
struct SText
{
    SText() {};
	SText(const std::string &text, CVector3f vPos, float r = 1.0,float g = 1.0, float b = 1.0,float a = 1.0){
		m_text = text; m_vPos = vPos;
		m_textColor[0]= r;m_textColor[1] = g;m_textColor[2] = b;m_textColor[3] = a;
	}
    CVector3f m_vPos;
	float m_textColor[4];
	std::string m_text;
};
/*

typedef std::vector<TSmartPointer<SText> > TextCollection;
*/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/

class IFont : public IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
		IFont(){}
		virtual void RenderText(SText *pText) = 0;
/*
		virtual void ClearAllText() = 0;
*/
		virtual ~IFont(){}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        IFont(const IFont &);
        IFont &operator =(const IFont &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
		byte          m_fontSize;
		std::string   m_fontFace;
		bool          m_bBold;
		bool          m_bItalic;

/*
		TextCollection m_allText;
*/	
};

#endif
