/****************************************************************************\
*                                                                            *
* 29.04.2006                                                                 *
* IStockGeometry - Header File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __ISTOCKGEOMETRY_H__
#define __ISTOCKGEOMETRY_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

enum ESTOCK_OBJECT{
	eQUAD,
	eCIRCLE
};

enum EBlendingMode
{
	EBM_NONE,
	EBM_ALPHA,
	EBM_COLOR,
};

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IStockGeometry : public IManagedObject
{
	/**************************************************************************\
	* PUBLIC CLASS FUNCTIONS                                                   *
	\**************************************************************************/
public:
	IStockGeometry(){}

	virtual void Render() = 0;

	virtual ~IStockGeometry(){}

	/**************************************************************************\
	* PROTECTED CLASS FUNCTIONS                                                *
	\**************************************************************************/
protected:

	/**************************************************************************\
	* PRIVATE CLASS FUNCTIONS                                                  *
	\**************************************************************************/
private:
	//Private copy constructor and assignment operator to prevent mistakes:
	IStockGeometry(const IStockGeometry &);
	IStockGeometry &operator =(const IStockGeometry &);

	virtual void Destroy() = 0;

	/**************************************************************************\
	* PROTECTED CLASS MEMBERS                                                  *
	\**************************************************************************/
protected:

	/**************************************************************************\
	* PRIVATE CLASS MEMBERS                                                    *
	\**************************************************************************/
private:

};

#endif