/****************************************************************************\
*                                                                            *
* 26.04.2006                                                                 *
* CFModSound - Header File                                                   *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CFMODSOUND_H__
#define __CFMODSOUND_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Sound/ISound.h>
#include <Sound/CFModSoundMgr.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CFModSound : public ISound
{
	friend class CFModSoundMgr;

	/**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
		
		virtual void Play();
		virtual void Pause();
		virtual void Stop();
                
		virtual ~CFModSound(){}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:

		CFModSound(CFModSoundMgr *);
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        CFModSound(const CFModSound &);
        CFModSound &operator =(const CFModSound &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:

		CFModSoundMgr * m_pSoundMgr;
		FMOD::Sound   * m_pSound;
		FMOD_MODE       m_pMode;
		FMOD::Channel * m_pChannel;
		
};

#endif
