/****************************************************************************\
*                                                                            *
* 25.04.2006                                                                 *
* CFModSoundMgr - Header File                                                *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CFMODSOUNDMGR_H__
#define __CFMODSOUNDMGR_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Sound/ISoundMgr.h>
#include <map>

#include <fmod.hpp>
#pragma comment(lib, "fmodex_vc.lib")

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CFModSound;
/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CFModSoundMgr : public ISoundMgr
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CFModSoundMgr();
		virtual bool Create();
		virtual void Destroy();
		virtual TSmartPointer<ISound> LoadSound(ESoundType sType, std::string const & fileName);
        
		void Play(CFModSound *);

		virtual ~CFModSoundMgr(){Destroy();}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        CFModSoundMgr(const CFModSoundMgr &);
        CFModSoundMgr &operator =(const CFModSoundMgr &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		FMOD::System *m_pSystem;
		std::map<std::string,FMOD::Sound *> m_currentSounds;
};

#endif
