/****************************************************************************\
*                                                                            *
* 25.04.2006                                                                 *
* ISoundMgr - Header File                                                    *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __ISOUNDMGR_H__
#define __ISOUNDMGR_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
#include <Memory/TSmartPointer.h>
#include <Sound/ISound.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

enum ESoundType{
	eDECOMPRESSED_SAMPLE,
	eCOMPRESSED_SAMPLE,
	eSTREAM
};

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class ISoundMgr : public IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
		ISoundMgr(){}
		virtual bool Create() = 0;
		virtual void Destroy() = 0;
		virtual TSmartPointer<ISound> LoadSound(ESoundType sType,std::string const & fileName) = 0;
		
		virtual ~ISoundMgr(){}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        ISoundMgr(const ISoundMgr &);
        ISoundMgr &operator =(const ISoundMgr &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        
};

#endif
