/****************************************************************************\
*                                                                            *
* 24.02.2006                                                                 *
* CW32TimeSource - Header File                                               *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __CW32TIMESOURCE_H__
#define __CW32TIMESOURCE_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "ITimeSource.h"

#pragma comment(lib, "winmm.lib")

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CW32TimeSource : public ITimeSource
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CW32TimeSource();
        
        virtual double GetTime() const;
        
        virtual ~CW32TimeSource() {};
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        CW32TimeSource(const CW32TimeSource &);
        CW32TimeSource &operator =(const CW32TimeSource &);
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        double m_dSecondsPerTick;
        
};

#endif
