/****************************************************************************\
*                                                                            *
* 15.03.2006                                                                 *
* CKillBirdApp - Header File                                                 *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __CKILLBIRDAPP_H__
#define __CKILLBIRDAPP_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Misc/CStdApp.h>
#include <Display/Windows/IWindow.h>
#include <Display/Windows/CConsoleWindow.h>
#include <Input/IInputHandler.h>
#include <Timer/CClock.h>
#include "CGameCtrl.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CKillBirdApp : public CStdApp, private IWindowHandler /*Debug:*/, private IInputHandler
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CKillBirdApp() : CStdApp() {Clear();}

        virtual ~CKillBirdApp() {Destroy();}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        virtual bool Create();
        virtual bool Update();
        virtual void Destroy();
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        void Clear();
        bool CreateWindows();
		bool SetupRenderEngine();
        void OnWndDestroy();
        //Zum Bestimmen von Keycodes
        virtual bool OnKeyDown(dword dwKey);
        virtual bool OnKeyUp(dword dwKey);

        //Private copy constructor and assignment operator to prevent mistakes:
        CKillBirdApp(const CKillBirdApp &);
        CKillBirdApp &operator =(const CKillBirdApp &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        TSmartPointer<IWindow> m_pWindow;
        TSmartPointer<CClock> m_pClock;

        bool m_bShutdown;
        CConsoleWindow m_Console;
        CGameCtrl m_GameCtrl;
};

#endif
