/****************************************************************************\
*                                                                            *
* 02.05.2006                                                                 *
* CAiBirdCtrl - Header File                                             *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CAIBIRDCTRL_H__
#define __CAIBIRDCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Misc/IObserver.h>
#include "IBirdCtrl.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CGameCtrl;
class CBuildingObj;

enum EAiBirdState
{
	EABS_ATTACKING,
	EABS_TO_TURN_POINT,
	EABS_TURNING
};

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CAiBirdCtrl : public IBirdCtrl, private IObserver
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CAiBirdCtrl(CGameCtrl *pGameCtrl);

		virtual void Update(float dt);

        virtual void GetDir(CVector3f &vDir);
        virtual bool GetRot(CVector3f &vRot);
        virtual bool Shoot();

        virtual ~CAiBirdCtrl();

    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:

    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        const CVector3f GetAttackPoint();
        virtual void Notify();

        //Private copy constructor and assignment operator to prevent mistakes:
        CAiBirdCtrl(const CAiBirdCtrl &);
        const CAiBirdCtrl &operator =(const CAiBirdCtrl &);

    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:

    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		CGameCtrl *m_pGameCtrl;
		EAiBirdState m_State;
		CBuildingObj *m_pNextTarget;
		CVector3f m_vTurnPoint;
        CVector3f m_vAttackPoint;
		CVector3f m_vRot;
};

#endif
