/****************************************************************************\
*                                                                            *
* 02.05.2006                                                                 *
* CAiKamikazeCtrl - Header File                                             *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CAIKAMIKAZECTRL_H__
#define __CAIKAMIKAZECTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Misc/IObserver.h>
#include "IBirdCtrl.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CGameCtrl;
class CBuildingObj;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CAiKamikazeCtrl : public IBirdCtrl, private IObserver
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CAiKamikazeCtrl(CGameCtrl *pGameCtrl);

		virtual void Update(float dt);

        virtual void GetDir(CVector3f &vDir);
        virtual bool GetRot(CVector3f &vRot);
        virtual bool Shoot();

        virtual ~CAiKamikazeCtrl();

    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:

    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        const CVector3f GetAttackPoint();
        virtual void Notify();

        //Private copy constructor and assignment operator to prevent mistakes:
        CAiKamikazeCtrl(const CAiKamikazeCtrl &);
        const CAiKamikazeCtrl &operator =(const CAiKamikazeCtrl &);

    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:

    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		CGameCtrl *m_pGameCtrl;
		CBuildingObj *m_pNextTarget;
        CVector3f m_vAttackPoint;
		CVector3f m_vRot;
};

#endif
