/****************************************************************************\
*                                                                            *
* 02.05.2006                                                                 *
* IBirdCtrl - Header File                                                  *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __IBIRDCTRL_H__
#define __IBIRDCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
#include <Math/TVector3.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CBirdObj;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IBirdCtrl : public IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
	public:
		IBirdCtrl();

		virtual void SetBird(CBirdObj *pBird);

		virtual void Update(float dt) = 0;

		virtual void GetDir(CVector3f &vDir) = 0;
		virtual bool GetRot(CVector3f &vRot) = 0;
		virtual bool Shoot() = 0;

		virtual ~IBirdCtrl();

    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
	protected:

    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
	private:
		//Private copy constructor and assignment operator to prevent mistakes:
		IBirdCtrl(const IBirdCtrl &);
		const IBirdCtrl &operator =(const IBirdCtrl &);

    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
	protected:
		CBirdObj *m_pBird;

    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
	private:
};

#endif
