/****************************************************************************\
*                                                                            *
* 03.06.2006                                                                 *
* CHqBuildingObj - Header File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CHQBUILDINGOBJ_H__
#define __CHQBUILDINGOBJ_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "CBuildingObj.h"
#include <Misc/Functors.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CHqBuildingObj : public CBuildingObj
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CHqBuildingObj(CGameCtrl *pGameCtrl, const TSmartPointer<IFunctor> &pHqDestroyedCb,
			const TSmartPointer<IParamFunctor> &pHqHitCb);

		virtual void SetHitpoints(float fHitpoints);
        
        virtual ~CHqBuildingObj();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        CHqBuildingObj(const CHqBuildingObj &);
        const CHqBuildingObj &operator =(const CHqBuildingObj &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        TSmartPointer<IFunctor> m_pHqDestroyedCallback;
		TSmartPointer<IParamFunctor> m_pHqHitCallback;
};

#endif
