/****************************************************************************\
*                                                                            *
* 02.05.2006                                                                 *
* ITowerCtrl - Header File                                                   *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __ITOWERCTRL_H__
#define __ITOWERCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
#include <Math/TVector3.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CTowerObj;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class ITowerCtrl : public IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
	public:
		ITowerCtrl();

		virtual void SetTower(CTowerObj *pTower);

		virtual void Update(float dt) = 0;

		virtual bool GetRot(CVector3f &vRot) = 0;
		virtual bool Shoot() = 0;

		virtual ~ITowerCtrl();

    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
	protected:

    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
	private:
		//Private copy constructor and assignment operator to prevent mistakes:
		ITowerCtrl(const ITowerCtrl &);
		const ITowerCtrl &operator =(const ITowerCtrl &);

    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
	protected:
		CTowerObj *m_pTower;

    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
	private:
};

#endif
