/****************************************************************************\
*                                                                            *
* 25.04.2006                                                                 *
* CObjCamCtrl - Source File                                                  *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "CObjCamCtrl.h"
#include "Display/Camera/CCamera.h"

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
CObjCamCtrl::CObjCamCtrl() : m_vOffset(0.0f, 0.0f, 0.0f), m_bLookAtObject(false), m_bObjectSpace(false)
{

}

void CObjCamCtrl::Update()
{
    if(IsEnabled() && (bool)m_pGameObj)
    {
        CVector3f vTmp;
        if(m_bObjectSpace)
        {
            CMatrix44 mat;
            CVector3f tmp(m_pGameObj->GetRot());
            tmp.m_X = tmp.m_Z = 0.0f;
            mat.RotationZXY(tmp);
            vTmp = mat * m_vOffset;
        }
        else
        {
            vTmp = m_vOffset;
        }
        m_pCamera->SetPos(m_pGameObj->GetPos() + vTmp);

        //Make the camera look at the object?
        if(m_bLookAtObject)
        {
            CVector3f tmp(m_pGameObj->GetRot());
            tmp.m_X = tmp.m_Z = 0.0f;
            m_pCamera->SetRot(tmp);
//            m_pCamera->LookAt(m_pGameObj->GetPos(), m_pGameObj->GetUp());
        }
        else
        {
            m_pCamera->SetRot(m_pGameObj->GetRot());
        }
    }
}

void CObjCamCtrl::SetGameObj(const TSmartPointer<IGameObj> &pGameObj)
{
    m_pGameObj = pGameObj;
}

void CObjCamCtrl::SetOffset(const CVector3f &vOffset, bool bLookAtObject, bool bObjectSpace)
{
    m_vOffset = vOffset;

    m_bLookAtObject = bLookAtObject;
    m_bObjectSpace = bObjectSpace;
}

CObjCamCtrl::~CObjCamCtrl()
{
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/


