/****************************************************************************\
*                                                                            *
* 24.04.2006                                                                 *
* CObjCamCtrl - Header File                                                  *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
* This Camera control just sets position and direction to those of a given   *
* game object (+ an offset).                                                 *
*                                                                            *
\****************************************************************************/

#ifndef __COBJCAMCTRL_H__
#define __COBJCAMCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Display/Camera/ICamCtrl.h>
#include "Objects/IGameObj.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CObjCamCtrl : public ICamCtrl
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CObjCamCtrl();

        void Update();

        void SetGameObj(const TSmartPointer<IGameObj> &pGameObj);
        void SetOffset(const CVector3f &vOffset, bool bLookAtObject, bool bObjectSpace);
        
        virtual ~CObjCamCtrl();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        CObjCamCtrl(const CObjCamCtrl &);
        const CObjCamCtrl &operator =(const CObjCamCtrl &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        TSmartPointer<IGameObj> m_pGameObj;
        CVector3f m_vOffset;
        bool m_bLookAtObject;      //If false, Camera-rot = object-rot
        bool m_bObjectSpace;
};

#endif
