/****************************************************************************\
*                                                                            *
* 07.05.2006                                                                 *
* CStartObj - Source File                                                 *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "CStartObj.h"
#include "CStartRep.h"
#include <CEngineFactory.h>

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
CStartObj::CStartObj(CGameCtrl *pGameCtrl, const CVector3f &vPos)
	: ICollidableObj(pGameCtrl, EOT_STARTPOS)
{
	SetPos(vPos);
    CStartRep *pRep = new CStartRep();
    if(!pRep->Create(pGameCtrl->GetSceneGraph(), "Data/models/startpodest.fbx", this))
    {
        LOG(TL_ERROR, "Error: pRep->Create failed in CStartObj::CStartObj");
    }

    m_pRepresentation = (IRepresentation *) pRep;
    m_pRepresentation->SetPickable(false);

	//Create the building actor
	CEngineFactory::InstancePtr()->GetPhysicsMgr()->BeginActorCreation(GetTransformation(), ECG_BUILDING, false);
	CAABox3f aabox(m_pRepresentation->GetOriginalBoundingBox());
	CMatrix44 mat;
	mat.Translation(aabox.Center());
	CEngineFactory::InstancePtr()->GetPhysicsMgr()->AddCube(mat, aabox.Size());
	SetActor(CEngineFactory::InstancePtr()->GetPhysicsMgr()->FinishActorCreation());
}

void CStartObj::CollidedWith(IGameObj *pOther)
{
}

void CStartObj::LevelDone()
{
}

CStartObj::~CStartObj()
{

}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/
void CStartObj::SubUpdate(float dt)
{

}