/****************************************************************************\
*                                                                            *
* 13.06.2006                                                                 *
* CTreeObj - Header File                                                     *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CTREEOBJ_H__
#define __CTREEOBJ_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "Objects/ICollidableObj.h"
#include "CGameCtrl.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CForest;
/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CTreeObj : public ICollidableObj
{

	/**************************************************************************\
	* PUBLIC CLASS FUNCTIONS                                                   *
	\**************************************************************************/
	public:
		CTreeObj(CGameCtrl *pGameCtrl, const std::string &sModel);

		void Plant();

		virtual bool GrowIn(CForest *forest);

		virtual void CollidedWith(IGameObj *pOther);

		virtual ~CTreeObj();

	/**************************************************************************\
	* PROTECTED CLASS FUNCTIONS                                                *
	\**************************************************************************/
	protected:

	/**************************************************************************\
	* PRIVATE CLASS FUNCTIONS                                                  *
	\**************************************************************************/
	private:
		virtual void SubUpdate(float dt);

		//Private copy constructor and assignment operator to prevent mistakes:
		CTreeObj(const CTreeObj &);
		const CTreeObj &operator =(const CTreeObj &);

	/**************************************************************************\
	* PROTECTED CLASS MEMBERS                                                  *
	\**************************************************************************/
	protected:

	/**************************************************************************\
	* PRIVATE CLASS MEMBERS                                                    *
	\**************************************************************************/
	private:
};

#endif
