/****************************************************************************\
*                                                                            *
* 12.04.2006                                                                 *
* CMainMenuState - Header File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CMAINMENUSTATE_H__
#define __CMAINMENUSTATE_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Display/Gui/CGuiMgr.h>
#include <Display/Gui/IGuiObject.h>
#include "IGameState.h"
#include <Sound/ISound.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CMainMenuState : public IGameState
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CMainMenuState() {Clear();}
        
        virtual bool Create(CGameCtrl *pGameCtrl);
        virtual void Enter();
        virtual bool Update();
        virtual void Leave();
        virtual void Destroy();

        //Button callback functions
        dword OnNewGame(dword);
        dword OnQuit(dword);
        
        virtual ~CMainMenuState() {Destroy();}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        void Clear();
        //Private copy constructor and assignment operator to prevent mistakes:
        CMainMenuState(const CMainMenuState &);
        const CMainMenuState &operator =(const CMainMenuState &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        TSmartPointer<IGuiObject> m_pGuiMenu;
        bool m_bRun;

        //For quicker access
        TSmartPointer<CGuiMgr> m_pGuiMgr;
		TSmartPointer<ISound>  m_pBgSound;
};

#endif
