/****************************************************************************\
*                                                                            *
* 21.04.2006                                                                 *
* CNewLevelState - Header File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CNEWLEVELSTATE_H__
#define __CNEWLEVELSTATE_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/TSmartPointer.h>
#include <Display/IRepresentation.h>
#include "IGameState.h"
#include <Display/Gui/CGuiButton.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CNewLevelState : public IGameState
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CNewLevelState() {Clear();}

        virtual bool Create(CGameCtrl *pGameCtrl);
        virtual void Enter();
        virtual bool Update();
        virtual void Leave();
        virtual void Destroy();

		dword OnContinue(dword dwButtonId);

        virtual ~CNewLevelState() {Destroy();}        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        void Clear();
        //Private copy constructor and assignment operator to prevent mistakes:
        CNewLevelState(const CNewLevelState &);
        const CNewLevelState &operator =(const CNewLevelState &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		TSmartPointer<IGuiObject> m_pLoadingScreen;
		TSmartPointer<CGuiButton> m_pContinue;

		bool m_bSkipUpdate;
};

#endif
