/****************************************************************************\
*                                                                            *
* 21.04.2006                                                                 *
* CPostGameState - Header File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CPOSTGAMESTATE_H__
#define __CPOSTGAMESTATE_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/TSmartPointer.h>
#include <Display/IRepresentation.h>
#include "IGameState.h"
#include <Display/Gui/IGuiObject.h>
#include <Display/Gui/CGuiText.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CPostGameState : public IGameState
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CPostGameState() {Clear();}

        virtual bool Create(CGameCtrl *pGameCtrl);
        virtual void Enter();
        virtual bool Update();
        virtual void Leave();
        virtual void Destroy();

		void GameWon(bool bWon);

		dword OnContinue(dword dwButtonId);

        virtual ~CPostGameState() {Destroy();}        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        void Clear();
        //Private copy constructor and assignment operator to prevent mistakes:
        CPostGameState(const CPostGameState &);
        const CPostGameState &operator =(const CPostGameState &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		TSmartPointer<IGuiObject> m_pRootObject;
		TSmartPointer<IGuiObject> m_pBgScreenLost;
		TSmartPointer<IGuiObject> m_pBgScreenWon;
		TSmartPointer<CGuiText> m_pScoreText;
		TSmartPointer<IGuiObject> m_pContinue;
};

#endif
